@rem
@rem Copyright 2015 the original author or authors.
@rem
@rem Licensed under the Apache License, Version 2.0 (the "License");
@rem you may not use this file except in compliance with the License.
@rem You may obtain a copy of the License at
@rem
@rem      https://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.
@rem

@if "%DEBUG%" == "" @echo off
@rem ##########################################################################
@rem
@rem  find_channels startup script for Windows
@rem
@rem ##########################################################################

@rem Set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" setlocal

set DIRNAME=%~dp0
if "%DIRNAME%" == "" set DIRNAME=.
set APP_BASE_NAME=%~n0
set APP_HOME=%DIRNAME%..

@rem Resolve any "." and ".." in APP_HOME to make it shorter.
for %%i in ("%APP_HOME%") do set APP_HOME=%%~fi

@rem Add default JVM options here. You can also use JAVA_OPTS and FIND_CHANNELS_OPTS to pass JVM options to this script.
set DEFAULT_JVM_OPTS=

@rem Find java.exe
if defined JAVA_HOME goto findJavaFromJavaHome

set JAVA_EXE=java.exe
%JAVA_EXE% -version >NUL 2>&1
if "%ERRORLEVEL%" == "0" goto init

echo.
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:findJavaFromJavaHome
set JAVA_HOME=%JAVA_HOME:"=%
set JAVA_EXE=%JAVA_HOME%/bin/java.exe

if exist "%JAVA_EXE%" goto init

echo.
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:init
@rem Get command-line arguments, handling Windows variants

if not "%OS%" == "Windows_NT" goto win9xME_args

:win9xME_args
@rem Slurp the command line arguments.
set CMD_LINE_ARGS=
set _SKIP=2

:win9xME_args_slurp
if "x%~1" == "x" goto execute

set CMD_LINE_ARGS=%*

:execute
@rem Setup the command line

set CLASSPATH=%APP_HOME%\lib\main;%APP_HOME%\lib\main;%APP_HOME%\lib\main;%APP_HOME%\lib\sod-mock-4.0.0-SNAPSHOT.jar;%APP_HOME%\lib\sod-bag-4.0.0-SNAPSHOT.jar;%APP_HOME%\lib\sod-util-4.0.0-SNAPSHOT.jar;%APP_HOME%\lib\sod-model-4.0.0-SNAPSHOT.jar;%APP_HOME%\lib\TauP-2.4.6-SNAPSHOT.jar;%APP_HOME%\lib\seisFile-2.0.0-SNAPSHOT.jar;%APP_HOME%\lib\seedCodec-1.0.12-SNAPSHOT.jar;%APP_HOME%\lib\oregondsp-2011.jar;%APP_HOME%\lib\hsqldb-2.4.0.jar;%APP_HOME%\lib\jline-0.9.94.jar;%APP_HOME%\lib\jsap-2.1.jar;%APP_HOME%\lib\jing-20091111.jar;%APP_HOME%\lib\rngconv-20030225.jar;%APP_HOME%\lib\woodstox-core-6.0.3.jar;%APP_HOME%\lib\jetty-servlet-9.4.5.v20180619.jar;%APP_HOME%\lib\msgpack-core-0.8.13.jar;%APP_HOME%\lib\json-20170516.jar;%APP_HOME%\lib\hibernate-ehcache-5.4.11.Final.jar;%APP_HOME%\lib\hibernate-c3p0-5.4.11.Final.jar;%APP_HOME%\lib\hibernate-core-5.4.11.Final.jar;%APP_HOME%\lib\velocity-tools-2.0.jar;%APP_HOME%\lib\dcwpo_browse-1.0.jar;%APP_HOME%\lib\javacsv-2.0.jar;%APP_HOME%\lib\slf4j-log4j12-1.7.30.jar;%APP_HOME%\lib\ehcache-2.10.6.jar;%APP_HOME%\lib\slf4j-api-1.7.30.jar;%APP_HOME%\lib\rxtx-2.1.7.jar;%APP_HOME%\lib\msv-core-2013.6.1.jar;%APP_HOME%\lib\httpclient-4.5.9.jar;%APP_HOME%\lib\mysql-connector-java-5.1.47.jar;%APP_HOME%\lib\javamail-1.3.2.jar;%APP_HOME%\lib\activation-1.0.2.jar;%APP_HOME%\lib\isti.util-20120201.jar;%APP_HOME%\lib\junit-3.8.1.jar;%APP_HOME%\lib\stax2-api-4.2.jar;%APP_HOME%\lib\jetty-security-9.4.5.v20180619.jar;%APP_HOME%\lib\hibernate-commons-annotations-5.1.0.Final.jar;%APP_HOME%\lib\jboss-logging-3.3.2.Final.jar;%APP_HOME%\lib\javax.persistence-api-2.2.jar;%APP_HOME%\lib\javassist-3.24.0-GA.jar;%APP_HOME%\lib\byte-buddy-1.10.7.jar;%APP_HOME%\lib\struts-taglib-1.3.8.jar;%APP_HOME%\lib\struts-tiles-1.3.8.jar;%APP_HOME%\lib\struts-core-1.3.8.jar;%APP_HOME%\lib\antlr-2.7.7.jar;%APP_HOME%\lib\jboss-transaction-api_1.2_spec-1.1.1.Final.jar;%APP_HOME%\lib\jandex-2.1.1.Final.jar;%APP_HOME%\lib\classmate-1.5.1.jar;%APP_HOME%\lib\jaxb-runtime-2.3.1.jar;%APP_HOME%\lib\jaxb-api-2.3.1.jar;%APP_HOME%\lib\javax.activation-api-1.2.0.jar;%APP_HOME%\lib\dom4j-2.1.1.jar;%APP_HOME%\lib\c3p0-0.9.5.3.jar;%APP_HOME%\lib\commons-chain-1.1.jar;%APP_HOME%\lib\commons-validator-1.3.1.jar;%APP_HOME%\lib\commons-digester-1.8.jar;%APP_HOME%\lib\commons-beanutils-1.7.0.jar;%APP_HOME%\lib\velocity-1.6.2.jar;%APP_HOME%\lib\commons-collections-3.2.1.jar;%APP_HOME%\lib\commons-logging-1.2.jar;%APP_HOME%\lib\dom4j-1.1.jar;%APP_HOME%\lib\oro-2.0.8.jar;%APP_HOME%\lib\sslext-1.2-0.jar;%APP_HOME%\lib\xsdlib-2013.6.1.jar;%APP_HOME%\lib\isorelax-20090621.jar;%APP_HOME%\lib\httpcore-4.4.11.jar;%APP_HOME%\lib\commons-codec-1.11.jar;%APP_HOME%\lib\log4j-1.2.17.jar;%APP_HOME%\lib\isti.util.toplevel-1.0USC.jar;%APP_HOME%\lib\jdom-b9.jar;%APP_HOME%\lib\jetty-server-9.4.5.v20180619.jar;%APP_HOME%\lib\txw2-2.3.1.jar;%APP_HOME%\lib\istack-commons-runtime-3.0.7.jar;%APP_HOME%\lib\stax-ex-1.8.jar;%APP_HOME%\lib\FastInfoset-1.2.15.jar;%APP_HOME%\lib\mchange-commons-java-0.2.15.jar;%APP_HOME%\lib\commons-lang-2.4.jar;%APP_HOME%\lib\relaxngDatatype-20020414.jar;%APP_HOME%\lib\javax.servlet-api-3.1.0.jar;%APP_HOME%\lib\jetty-http-9.4.5.v20180619.jar;%APP_HOME%\lib\jetty-io-9.4.5.v20180619.jar;%APP_HOME%\lib\jetty-util-9.4.5.v20180619.jar;%APP_HOME%\lib\sod-4.0.0-SNAPSHOT-WEBSTATUS.jar

@rem Execute find_channels
"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %FIND_CHANNELS_OPTS%  -classpath "%CLASSPATH%" edu.sc.seis.sod.tools.find_channels %CMD_LINE_ARGS%

:end
@rem End local scope for the variables with windows NT shell
if "%ERRORLEVEL%"=="0" goto mainEnd

:fail
rem Set variable FIND_CHANNELS_EXIT_CONSOLE if you need the _script_ return code instead of
rem the _cmd.exe /c_ return code!
if  not "" == "%FIND_CHANNELS_EXIT_CONSOLE%" exit 1
exit /b 1

:mainEnd
if "%OS%"=="Windows_NT" endlocal

:omega
